// *****************************************************************************
// *                                                                           *
// *  BiqCrunch is a semidefinite-based solver for binary quadratic problems.  *
// *  It uses a branch-and-bound method featuring an improved semidefinite     *
// *  bounding procedure, mixed with a polyhedral approach. BiqCrunch uses     *
// *  particular input files format to describe the combinatorial problems.    *
// *                                                                           *
// *   Copyright (C) 2010-2014 Nathan Krislock, Jérôme Malick, Frédéric Roupin *
// *                                                                           *
// *                 http://www-lipn.univ-paris13.fr/BiqCrunch/                *
// *									       *
// *****************************************************************************
//									       *
//    This program is free software: you can redistribute it and/or modify     *
//    it under the terms of the GNU General Public License as published by     *
//    the Free Software Foundation, either version 3 of the License, or        *
//    (at your option) any later version.                                      *
//                                                                             *
//    This program is distributed in the hope that it will be useful,          *
//    but WITHOUT ANY WARRANTY; without even the implied warranty of           *
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *
//    GNU General Public License for more details.                             *
//                                                                             *
//    You should have received a copy of the GNU General Public License        *
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.    *
//                                                                             *
// *****************************************************************************
// Authors : N. Krislock, F. Roupin 2010

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <time.h>
#include <memory.h>

#include "bb.h"
#include "biqcrunch.h"

/**
 * Name of the heuristic printed in the output file
 */
char heur_name[] = "user";



int BC_allocHeuristic(Problem *P0) {
	return 1;
}
void BC_freeHeuristic() {
}

double BC_runHeuristic(Problem *P0, Problem *P, BobNode *node, int *x, int heuristic_code){

	double best;

	if (P0->max_problem) best = -BIG_NUMBER; else best = BIG_NUMBER;

	switch (heuristic_code) {
	case PRIMAL_HEUR:

		break;
	case SDP_BOUND_HEUR:

		break;
	case ROUNDING_HEUR:
	
		break;
	default:
		printf("Choosen heuristic doesn't exist\n");
		exit(1);
	}

	return best;

}
